#!/usr/bin/env python
# -*- coding: utf-8 -*-

#
# Fichero:	generaCSV.py
#
# Descripcion:	Programa que hace un 'parse' del fichero XML generado por Gescen para el alta de usuarios en lliurex y 
#               que crea un fichero CSV con los campos requeridos. A continuacin se puede convertir a SQL para importarlo desde MySQL
#

#
# FORMATO: python generaCSV.py llxgesc.XML csvAlumnos.csv 
#
# 
# Autor: Joaquin Lpez Snchez-Montas 

import sys, codecs, xml.etree.ElementTree as ET
from xml.etree.ElementTree import tostring
reload(sys)
sys.setdefaultencoding("utf-8")



def usage():
	
	print "USO:python generaCSV.py llxgesc.XML csvAlumnos.csv "
	sys.exit(1)

if len(sys.argv) < 3:
	usage()

else:

	try:
             # Open a file --> para obtener los datos de los alumnos y pasarlos a SQL
             fo = codecs.open(sys.argv[2], encoding='utf-8', mode='w+')
             #contrasenya=unicode("contrasea", 'utf-8')
             cabecera="usuario,contrasenya,nombre,apellidos,curso,grupo\n"
             #cabecera="usuario"+","+contrasenya+","+"nombre"+","+"apellidos"+","+"curso"+","+"grupo"
             #cabecera2=cabecera.encode('utf-8') 
             fo.write(cabecera)
             # Create the root of the ElementTree from file
             root = ET.parse(sys.argv[1]).getroot()
       
             # Obtenemos un iterador para los nodos de los alumnos 
	     iteradorAlumne = root.getiterator("alumne")
             # Bucle que usa el iterador iteradorAlumnes
             for alumne in iteradorAlumne:    
                 # Para encontrar un sub-elemento con una etiqueta de texto usamos find()
                 # Buscamos el n de expediente del alumno en el diccionario 
                 # y le aadimos los nuevos smbolos uid y password
		 uid=str(alumne.find("uid").text)
		 password=str(alumne.find("password").text)
		 nom=str(alumne.find("nom").text)
                 nom2=unicode(nom, 'utf-8')
		 cognoms=str(alumne.find("cognoms").text)
                 cognoms2=unicode(cognoms, 'utf-8')
		 curs=str(alumne.find("curs").text)
		 grup=str(alumne.find("grup").text)

                 
 		 # linea que insertamos en el fichero CSV 
		 cadena=uid+","+password+","+nom2+","+cognoms2+","+curs+","+grup+"\n"
	         #print cadena
		 cadena2=cadena.encode('utf-8')              
                 fo.write(cadena)
             
             # Close opend file
             fo.close()
             
        except Exception as e:
		print e
