# coding=utf-8
#-------------
#
# Fichero:	modificaLLxgesc1516.py
#
# Descripcion:	Programa que hace un 'parse' del fichero XML generado por ITACA para el alta de usuarios en lliurex y 
#               que añade dos campos nuevos a cada alumno/profesor que son <uid> y <password>
#
# Lo que permite es tener dados de alta en lliurex los usuarios con el login 'nia' y el passwd 'dni' (sin letra), y a los profesores con su login y DNI(sin letra). A los alumnos que no tienen DNI, se les asigna como contraseña el nia.
# En el fichero logins.csv (datos profesores) hay un listado de dni(sin letra),login por cada profesor del centro.
#
# FORMATO: python modificaLLxgesc1516.py llxgesc.XML logins.csv llxgesc_MODIFICADO.XML
# 
# Autor: Joaquin López Sánchez-Montañés 

import sys, xml.etree.ElementTree as ET
from xml.etree.ElementTree import tostring

# Función que lee el fichero csv y construye un diccionario de pares clave,valor
def read_csv(file):
	try:
               logins_dict={}   # defino el diccionario que guardará los pares clave,valor
               f=open(file,"r")
	       lines=f.readlines()
	       f.close()

               for fila in lines:
                        try:
                            fila=fila.strip("\n")
                            dni,login=fila.split(",")
                            # vamos construyendo el diccionario fila a fila
                            logins_dict[dni]=login 
                            
                	except:
			    pass
			
	       return logins_dict
	except:
		
               print "File not found !"
	       sys.exit(1)
	
#def read_csv

def usage():
	
	print "USO:python ./modificaLLxgesc1516.py llxgesc.XML logins.csv llxgesc_MODIFICADO.XML"
	sys.exit(1)

if len(sys.argv) < 4:
	usage()

else:

    try:
         dicccionario_nia={}   # defino el diccionario que guardará los pares clave,valor para que no se repita el nia en los alumnos
         loginsProfesores=read_csv(sys.argv[2])
         # Create the root of the ElementTree from file
         root = ET.parse(sys.argv[1]).getroot()
         seccionAlumnes=root.find("alumnes")
         # Obtenemos un iterador para los nodos de los alumnos
         iteradorAlumne = root.getiterator("alumne")  
         # Si utilizo el nuevo método iter(), me salen menos alumnos :-|
         cuentaAlumnos=0
         # Bucle que usa el iterador iteradorAlumnes
         for alumne in iteradorAlumne:
             # Para encontrar un sub-elemento con una etiqueta de texto usamos find()
             # Buscamos el nia del alumno en el diccionario 
             # y le añadimos los nuevos símbolos uid y password
             nia=str(alumne.find("nia").text)

             if nia not in dicccionario_nia:       
             	nuevo_simbolo = ET.SubElement(alumne, "uid")
                nuevo_simbolo.text = nia
             	nuevo_simbolo = ET.SubElement(alumne, "password")
             	dni=str(alumne.find("nif").text)
             	dni=dni[1:9]
                # comprueba si el alumno tiene DNI, en caso contrario le asigna el NIA al campo dni
             	if len(dni)<8:
		   dni = nia
             	nuevo_simbolo.text = dni
                dicccionario_nia[nia]=dni
                cuentaAlumnos+=1
             # si está repetido el nia, eliminamos el nodo repetido del fichero
             else:
               seccionAlumnes.remove(alumne) 
	 
         # Obtenemos un iterador para los nodos de los profesores 
         iteradorProfessor = root.getiterator("professor")
         cuentaProfesores=0
         # Bucle que usa el iterador iteradorProfessors
         for professor in iteradorProfessor:
             dni = professor.find("document").text
             # eliminamos los espacios en blanco del campo nif
             dni = dni.replace(" ","")
             dni = dni[1:9]
             # Buscamos el nº de dni del profesor en el diccionario 
             # y si existe le añadimos los nuevos símbolos uid y password
             if loginsProfesores.has_key(dni):
                 nuevo_simbolo = ET.SubElement(professor, "uid")
                 nuevo_simbolo.text = loginsProfesores[dni]
                 nuevo_simbolo = ET.SubElement(professor, "password")
                 nuevo_simbolo.text = dni
                 cuentaProfesores+=1
             else:
                 print "No existe login para el profesor con DNI: ", dni
            
         print "El nº de alumnos es: ", cuentaAlumnos
         print "El nº de profesores es: ", cuentaProfesores
         # Ahora obtén el arbol entero desde la raíz
         tree = ET.ElementTree(root)
         # Convertimos el formato de fichero a UTF8
         lXml = tostring(tree.getroot(),'utf-8')
         lXml = "<?xml version='1.0' encoding='utf-8'?>\n%s" % lXml
         lFile = open(sys.argv[3], "w")
         lFile.write(lXml)
         lFile.close()

    except Exception as e:
        print e
